#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include <linux/wait.h>
#include "ppci.h"
#include <sys/stat.h>

void dump_reg(struct ppci *ppci, int minor ) {
  printf("Output data   = %x\n", ppci->data);
  printf("LED = %x\n", ppci->led);
  printf("Switch Register   = %x\n", ppci->sw);
  printf("Transfer Address   = %x\n", ppci->address);
  printf("Transfer Count = %x\n", ppci->length);
  printf("Mode   = %x\n", ppci->mode);
  printf("Status   = %x\n", ppci->status);
  printf("RetLength = %x\n", ppci->retlen);
  printf("FIFOLength = %x\n", ppci->fifolen);
}

main(int argc, char **argv) {
  int fd;
  int i = 0;
  int minor, direction, control=0;
  int buf_size, length, lentoread;
  int *data_buffer;
  struct ppci ppci;
  unsigned long count = 0;

  if( argc != 2 ) {
    printf("usage : read_ppci minor_number \n");
    exit(0);
  }
  minor = atoi(argv[1]);

  if( minor == 0 )
    fd = open("/dev/ppci0", O_RDWR);
  else if( minor == 1 )
    fd = open("/dev/ppci1", O_RDWR);
  else {
    printf("Illegal minor number! 0 or 1\n");
    exit(0);
  }
  if(fd==-1){
    printf("pcci open error");
    return;
  }


  direction = 0;
  if( ioctl(fd, PPCIIOC_RESET, direction) == -1 ){
    printf("ioctl PPCIIOC_RESET error...\n");
    exit(0);
  }
  if( ioctl(fd, PPCIIOC_DUMP_REGISTERS, &ppci) == -1 ){
    printf("ioctl PPCIIOC_GET_CONTROL error...\n");
    exit(0);
  }
  dump_reg(&ppci, minor);


  if( ioctl(fd, PPCIIOC_FIFO_CLEAR ) == -1 ){
    printf("ioctl PPCIIOC_FIFO_CLEAR error...\n");
    exit(0);
  }
}

