#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include "ppci.h"

void dump_reg(struct ppci *ppci, int minor ) {

  printf("Output data   = %x\n", ppci->data);
  printf("LED = %x\n", ppci->led);
  printf("Switch Register   = %x\n", ppci->sw);
  printf("Transfer Address   = %x\n", ppci->address);
  printf("Transfer Count = %x\n", ppci->length);
  printf("Mode   = %x\n", ppci->mode);
  printf("Status   = %x\n", ppci->status);
  printf("RetLength = %x\n", ppci->retlen);
  printf("FIFOLength = %x\n", ppci->fifolen);
}

main(int argc, char **argv) {
  int fd;
  unsigned int i,j;
  int minor, direction, control=0;
  int length, retlen;
  int *w_buffer, *r_buffer;
  struct ppci ppci;
  int loop = 0;
  int count = 128;

  if( argc != 2 ) {
    printf("usage : read_ppci minor_number\n");
    exit(0);
  }
  minor = atoi(argv[1]);

  if( minor == 0 )
    fd = open("/dev/ppci0", O_RDWR);
  else if( minor == 1 )
    fd = open("/dev/ppci1", O_RDWR);
  else {
    printf("Illegal minor number! 0 or 1\n");
    exit(0);
  }

  r_buffer = (int *)malloc(count*sizeof(int));
  w_buffer = (int *)malloc(count*sizeof(int));

  for(i = 0; i< count; i++)
    r_buffer[i] = 0;
  for(i = 0; i< count; i++)
    w_buffer[i] = 0xf0f0f000 + i;

  direction = 0;
  if( ioctl(fd, PPCIIOC_RESET, direction) == -1 ) {
    printf("ioctl PPCIIOC_RESET error...\n");
    exit(0);
  }
  if( ioctl(fd, PPCIIOC_DUMP_REGISTERS, &ppci) == -1 ) {
    printf("ioctl PPCIIOC_DUMP_REGISTERS error...\n");
    exit(0);
  }
 dump_reg(&ppci, minor);
 /*
 sleep(10);
 exit(0);
 */
  length = count*sizeof(int);
  while(1) {
    retlen = read(fd, r_buffer, length);
    if( retlen < 0 || retlen > length) {
      printf("read error occurred...\n");
      exit(0);
    }
    for(i = 0; i < count; i++) {
      if( w_buffer[i] != r_buffer[i] ) {
	printf("data error : loop = %d, i = %d\n", loop, i);
	printf("written data read data\n");
	for(j = 0; j < 128; j++)
	       printf("%x    %x\n", w_buffer[j], r_buffer[j]);
	free(r_buffer);
	free(w_buffer);
	close(fd);
	exit(0);
      }
      r_buffer[i] = 0;
    }
    loop++;
    if(!(loop % 10000))
      printf("loop = %d\n", loop);
  }
}







