#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include "ppci.h"

void dump_reg(struct ppci *ppci, int minor ) {

  printf("Output data   = %x\n", ppci->data);
  printf("LED = %x\n", ppci->led);
  printf("Switch Register   = %x\n", ppci->sw);
  printf("Transfer Address   = %x\n", ppci->address);
  printf("Transfer Count = %x\n", ppci->length);
  printf("Mode   = %x\n", ppci->mode);
  printf("Status   = %x\n", ppci->status);
  printf("RetLength = %x\n", ppci->retlen);
  printf("FIFOLength = %x\n", ppci->fifolen);
}

main(int argc, char **argv) {
  int fd;
  unsigned int i = 0;
  int minor, direction, control=0;
  int count, length, retlen;
  int *data_buffer;
  struct ppci ppci;

  if( argc != 3 ) {
    printf("usage : read_ppci minor_number count\n");
    exit(0);
  }
  minor = atoi(argv[1]);
  count = atoi(argv[2]);

  if( minor == 0 )
    fd = open("/dev/ppci0", O_RDWR);
  else if( minor == 1 )
    fd = open("/dev/ppci1", O_RDWR);
  else {
    printf("Illegal minor number! 0 or 1\n");
    exit(0);
  }

  data_buffer = (int *)malloc(count*sizeof(int));
  for(i = 0; i< count; i++)
    data_buffer[i] = 0;

  direction = 0;
  if( ioctl(fd, PPCIIOC_RESET, direction) == -1 ) {
    printf("ioctl PPCIIOC_RESET error...\n");
    exit(0);
  }
  /*
  if( ioctl(fd, PPCIIOC_DUMP_REGISTERS, &ppci) == -1 ) {
    printf("ioctl PPCIIOC_DUMP_REGISTERS error...\n");
    exit(0);
  }
  dump_reg(&ppci, minor);
  */
  length = count*sizeof(int);
  retlen = read(fd, data_buffer, length);
  printf("return length = %d\n", retlen);
  for( i = 0; i < retlen / sizeof(int); i++) {
    if(data_buffer[i] != 0x4030201) {
      printf("data error : i = %d, written data = 0x04030201 read data = %x\n", i, data_buffer[i]);
      exit(0);
    }	
    data_buffer[i] = 0;
  }
    
  /*
  for( i = 0; i < length / sizeof(int); i++)
    printf("data[%d]= %x in hex\n", i, data_buffer[i]);

  if( ioctl(fd, PPCIIOC_DUMP_REGISTERS, &ppci) == -1 ) {
    printf("ioctl PPCIIOC_DUMP_REGISTERS error...\n");
    exit(0);
  }
  */

  free(data_buffer);
  close(fd);
}

