#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include <linux/wait.h>
#include "ppci.h"

void dump_reg(struct ppci *ppci, int minor ) {

  printf("Output data   = %x\n", ppci->data);
  printf("LED = %x\n", ppci->led);
  printf("Switch Register   = %x\n", ppci->sw);
  printf("Transfer Address   = %x\n", ppci->address);
  printf("Transfer Count = %x\n", ppci->length);
  printf("Mode   = %x\n", ppci->mode);
  printf("Status   = %x\n", ppci->status);
}

main(int argc, char **argv) {
  int fd;
  unsigned int i = 0;
  int minor, direction, control=0;
  int data;
  struct ppci ppci;

  if( argc != 3 && argc != 4 ) {
    printf("usage : test_ppci minor_number direction{1:write,0:read} [control{1:control]\n");
    exit(0);
  }
  minor = atoi(argv[1]);
  direction = atoi(argv[2]);
  if( argc == 4 )
    control = atoi(argv[3]);
  if( minor == 0 )
    fd = open("/dev/ppci0", O_RDWR);
  else if( minor == 1 )
    fd = open("/dev/ppci1", O_RDWR);
  else {
    printf("Illegal minor number! 0 or 1\n");
    exit(0);
  }
  if( control ) {
    if( ioctl(fd, PPCIIOC_RELEASE_CONTROL, direction) == -1 ) {
      printf("ioctl PPCIIOC_RELEASE_CONTROL error...\n");
      exit(0);
    }
  }
  if( ioctl(fd, PPCIIOC_RESET, direction) == -1 ) {
    printf("ioctl PPCIIOC_RESET error...\n");
    exit(0);
  }
  if( ioctl(fd, PPCIIOC_DUMP_REGISTERS, &ppci) == -1 ) {
    printf("ioctl PPCIIOC_GET_CONTROL error...\n");
    exit(0);
  }
  dump_reg(&ppci, minor);

  for( i = 0; i < 1; i++) {
    if( direction ) {
      data = 0x33333333;
      if( ioctl(fd, PPCIIOC_PUT_DATA, &data) == -1 ) {
	printf("ioctl PPCIIOC_GET_CONTROL error...\n");
	exit(0);
      }
    } else {
      if( ioctl(fd, PPCIIOC_GET_DATA, &data) == -1 ) {
        printf("ioctl PPCIIOC_GET_CONTROL error...\n");
        exit(0);
      }
      printf("read data = %x in hex.\n", data);
    }
  }
  close(fd);
}
